/*This file is automatically generated by pkg.deepin.io/dbus-generator. Don't edit it*/
package accounts

import "pkg.deepin.io/lib/dbus"
import "pkg.deepin.io/lib/dbus/property"
import "reflect"
import "sync"
import "runtime"
import "fmt"
import "errors"

/*prevent compile error*/
var _ = fmt.Println
var _ = runtime.SetFinalizer
var _ = sync.NewCond
var _ = reflect.TypeOf
var _ = property.BaseObserver{}

type Accounts struct {
	Path     dbus.ObjectPath
	DestName string
	core     *dbus.Object

	signals       map[<-chan *dbus.Signal]struct{}
	signalsLocker sync.Mutex

	UserList   *dbusPropertyAccountsUserList
	GuestIcon  *dbusPropertyAccountsGuestIcon
	AllowGuest *dbusPropertyAccountsAllowGuest
}

func (obj *Accounts) _createSignalChan() <-chan *dbus.Signal {
	obj.signalsLocker.Lock()
	ch := getBus().Signal()
	obj.signals[ch] = struct{}{}
	obj.signalsLocker.Unlock()
	return ch
}
func (obj *Accounts) _deleteSignalChan(ch <-chan *dbus.Signal) {
	obj.signalsLocker.Lock()
	delete(obj.signals, ch)
	getBus().DetachSignal(ch)
	obj.signalsLocker.Unlock()
}
func DestroyAccounts(obj *Accounts) {
	obj.signalsLocker.Lock()
	defer obj.signalsLocker.Unlock()
	if obj.signals == nil {
		return
	}
	for ch, _ := range obj.signals {
		getBus().DetachSignal(ch)
	}
	obj.signals = nil

	runtime.SetFinalizer(obj, nil)

	dbusRemoveMatch("type='signal',path='" + string(obj.Path) + "',interface='org.freedesktop.DBus.Properties',sender='" + obj.DestName + "',member='PropertiesChanged'")
	dbusRemoveMatch("type='signal',path='" + string(obj.Path) + "',interface='com.deepin.daemon.Accounts',sender='" + obj.DestName + "',member='PropertiesChanged'")

	dbusRemoveMatch("type='signal',path='" + string(obj.Path) + "',interface='com.deepin.daemon.Accounts',sender='" + obj.DestName + "',member='UserAdded'")

	dbusRemoveMatch("type='signal',path='" + string(obj.Path) + "',interface='com.deepin.daemon.Accounts',sender='" + obj.DestName + "',member='UserDeleted'")

	obj.UserList.Reset()
	obj.GuestIcon.Reset()
	obj.AllowGuest.Reset()
}

func (obj *Accounts) AllowGuestAccount(allow bool) (_err error) {
	_err = obj.core.Call("com.deepin.daemon.Accounts.AllowGuestAccount", 0, allow).Store()
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

func (obj *Accounts) CreateGuestAccount() (user string, _err error) {
	_err = obj.core.Call("com.deepin.daemon.Accounts.CreateGuestAccount", 0).Store(&user)
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

func (obj *Accounts) CreateUser(name string, fullName string, type_ int32) (user dbus.ObjectPath, _err error) {
	_err = obj.core.Call("com.deepin.daemon.Accounts.CreateUser", 0, name, fullName, type_).Store(&user)
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

func (obj *Accounts) DeleteUser(name string, rmFiles bool) (_err error) {
	_err = obj.core.Call("com.deepin.daemon.Accounts.DeleteUser", 0, name, rmFiles).Store()
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

func (obj *Accounts) FindUserById(uid string) (user string, _err error) {
	_err = obj.core.Call("com.deepin.daemon.Accounts.FindUserById", 0, uid).Store(&user)
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

func (obj *Accounts) FindUserByName(name string) (user string, _err error) {
	_err = obj.core.Call("com.deepin.daemon.Accounts.FindUserByName", 0, name).Store(&user)
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

func (obj *Accounts) IsPasswordValid(password string) (ok bool, errReason string, errCode int32, _err error) {
	_err = obj.core.Call("com.deepin.daemon.Accounts.IsPasswordValid", 0, password).Store(&ok, &errReason, &errCode)
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

func (obj *Accounts) IsUsernameValid(name string) (ok bool, errReason string, errCode int32, _err error) {
	_err = obj.core.Call("com.deepin.daemon.Accounts.IsUsernameValid", 0, name).Store(&ok, &errReason, &errCode)
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

func (obj *Accounts) RandUserIcon() (iconFile string, _err error) {
	_err = obj.core.Call("com.deepin.daemon.Accounts.RandUserIcon", 0).Store(&iconFile)
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

func (obj *Accounts) ConnectUserAdded(callback func(objPath string)) func() {
	sigChan := obj._createSignalChan()
	go func() {
		for v := range sigChan {
			if v.Path != obj.Path || v.Name != "com.deepin.daemon.Accounts.UserAdded" || 1 != len(v.Body) {
				continue
			}
			if reflect.TypeOf(v.Body[0]) != reflect.TypeOf((*string)(nil)).Elem() {
				continue
			}

			callback(v.Body[0].(string))
		}
	}()
	return func() {
		obj._deleteSignalChan(sigChan)
	}
}

func (obj *Accounts) ConnectUserDeleted(callback func(objPath string)) func() {
	sigChan := obj._createSignalChan()
	go func() {
		for v := range sigChan {
			if v.Path != obj.Path || v.Name != "com.deepin.daemon.Accounts.UserDeleted" || 1 != len(v.Body) {
				continue
			}
			if reflect.TypeOf(v.Body[0]) != reflect.TypeOf((*string)(nil)).Elem() {
				continue
			}

			callback(v.Body[0].(string))
		}
	}()
	return func() {
		obj._deleteSignalChan(sigChan)
	}
}

type dbusPropertyAccountsUserList struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyAccountsUserList) SetValue(notwritable interface{}) {
	fmt.Println("com.deepin.daemon.Accounts.UserList is not writable")
}

func (this *dbusPropertyAccountsUserList) Get() []string {
	v, _ := this.GetValue()
	return v.([]string)
}
func (this *dbusPropertyAccountsUserList) GetValue() (interface{} /*[]string*/, error) {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "com.deepin.daemon.Accounts", "UserList").Store(&r)
	if err == nil && r.Signature().String() == "as" {
		return r.Value().([]string), nil
	}
	return *new([]string), err
}
func (this *dbusPropertyAccountsUserList) GetType() reflect.Type {
	return reflect.TypeOf((*[]string)(nil)).Elem()
}

type dbusPropertyAccountsGuestIcon struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyAccountsGuestIcon) SetValue(notwritable interface{}) {
	fmt.Println("com.deepin.daemon.Accounts.GuestIcon is not writable")
}

func (this *dbusPropertyAccountsGuestIcon) Get() string {
	v, _ := this.GetValue()
	return v.(string)
}
func (this *dbusPropertyAccountsGuestIcon) GetValue() (interface{} /*string*/, error) {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "com.deepin.daemon.Accounts", "GuestIcon").Store(&r)
	if err == nil && r.Signature().String() == "s" {
		return r.Value().(string), nil
	}
	return *new(string), err
}
func (this *dbusPropertyAccountsGuestIcon) GetType() reflect.Type {
	return reflect.TypeOf((*string)(nil)).Elem()
}

type dbusPropertyAccountsAllowGuest struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyAccountsAllowGuest) SetValue(notwritable interface{}) {
	fmt.Println("com.deepin.daemon.Accounts.AllowGuest is not writable")
}

func (this *dbusPropertyAccountsAllowGuest) Get() bool {
	v, _ := this.GetValue()
	return v.(bool)
}
func (this *dbusPropertyAccountsAllowGuest) GetValue() (interface{} /*bool*/, error) {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "com.deepin.daemon.Accounts", "AllowGuest").Store(&r)
	if err == nil && r.Signature().String() == "b" {
		return r.Value().(bool), nil
	}
	return *new(bool), err
}
func (this *dbusPropertyAccountsAllowGuest) GetType() reflect.Type {
	return reflect.TypeOf((*bool)(nil)).Elem()
}

func NewAccounts(destName string, path dbus.ObjectPath) (*Accounts, error) {
	if !path.IsValid() {
		return nil, errors.New("The path of '" + string(path) + "' is invalid.")
	}

	core := getBus().Object(destName, path)

	obj := &Accounts{Path: path, DestName: destName, core: core, signals: make(map[<-chan *dbus.Signal]struct{})}

	obj.UserList = &dbusPropertyAccountsUserList{&property.BaseObserver{}, core}
	obj.GuestIcon = &dbusPropertyAccountsGuestIcon{&property.BaseObserver{}, core}
	obj.AllowGuest = &dbusPropertyAccountsAllowGuest{&property.BaseObserver{}, core}

	dbusAddMatch("type='signal',path='" + string(path) + "',interface='org.freedesktop.DBus.Properties',sender='" + destName + "',member='PropertiesChanged'")
	dbusAddMatch("type='signal',path='" + string(path) + "',interface='com.deepin.daemon.Accounts',sender='" + destName + "',member='PropertiesChanged'")
	sigChan := obj._createSignalChan()
	go func() {
		typeString := reflect.TypeOf("")
		typeKeyValues := reflect.TypeOf(map[string]dbus.Variant{})
		typeArrayValues := reflect.TypeOf([]string{})
		for v := range sigChan {
			if v.Name == "org.freedesktop.DBus.Properties.PropertiesChanged" &&
				len(v.Body) == 3 &&
				reflect.TypeOf(v.Body[0]) == typeString &&
				reflect.TypeOf(v.Body[1]) == typeKeyValues &&
				reflect.TypeOf(v.Body[2]) == typeArrayValues &&
				v.Body[0].(string) == "com.deepin.daemon.Accounts" {
				props := v.Body[1].(map[string]dbus.Variant)
				for key, _ := range props {
					if false {
					} else if key == "UserList" {
						obj.UserList.Notify()

					} else if key == "GuestIcon" {
						obj.GuestIcon.Notify()

					} else if key == "AllowGuest" {
						obj.AllowGuest.Notify()
					}
				}
			} else if v.Name == "com.deepin.daemon.Accounts.PropertiesChanged" && len(v.Body) == 1 && reflect.TypeOf(v.Body[0]) == typeKeyValues {
				for key, _ := range v.Body[0].(map[string]dbus.Variant) {
					if false {
					} else if key == "UserList" {
						obj.UserList.Notify()

					} else if key == "GuestIcon" {
						obj.GuestIcon.Notify()

					} else if key == "AllowGuest" {
						obj.AllowGuest.Notify()
					}
				}
			}
		}
	}()

	dbusAddMatch("type='signal',path='" + string(obj.Path) + "',interface='com.deepin.daemon.Accounts',sender='" + obj.DestName + "',member='UserAdded'")

	dbusAddMatch("type='signal',path='" + string(obj.Path) + "',interface='com.deepin.daemon.Accounts',sender='" + obj.DestName + "',member='UserDeleted'")

	runtime.SetFinalizer(obj, func(_obj *Accounts) { DestroyAccounts(_obj) })
	return obj, nil
}
