/*This file is automatically generated by pkg.deepin.io/dbus-generator. Don't edit it*/
package bluez

import "pkg.deepin.io/lib/dbus"
import "pkg.deepin.io/lib/dbus/property"
import "reflect"
import "sync"
import "runtime"
import "fmt"
import "errors"

/*prevent compile error*/
var _ = fmt.Println
var _ = runtime.SetFinalizer
var _ = sync.NewCond
var _ = reflect.TypeOf
var _ = property.BaseObserver{}

type Network1 struct {
	Path     dbus.ObjectPath
	DestName string
	core     *dbus.Object

	signals       map[<-chan *dbus.Signal]struct{}
	signalsLocker sync.Mutex

	Connected *dbusPropertyNetwork1Connected
	Interface *dbusPropertyNetwork1Interface
	UUID      *dbusPropertyNetwork1UUID
}

func (obj *Network1) _createSignalChan() <-chan *dbus.Signal {
	obj.signalsLocker.Lock()
	ch := getBus().Signal()
	obj.signals[ch] = struct{}{}
	obj.signalsLocker.Unlock()
	return ch
}
func (obj *Network1) _deleteSignalChan(ch <-chan *dbus.Signal) {
	obj.signalsLocker.Lock()
	delete(obj.signals, ch)
	getBus().DetachSignal(ch)
	obj.signalsLocker.Unlock()
}
func DestroyNetwork1(obj *Network1) {
	obj.signalsLocker.Lock()
	defer obj.signalsLocker.Unlock()
	if obj.signals == nil {
		return
	}
	for ch, _ := range obj.signals {
		getBus().DetachSignal(ch)
	}
	obj.signals = nil

	runtime.SetFinalizer(obj, nil)

	dbusRemoveMatch("type='signal',path='" + string(obj.Path) + "',interface='org.freedesktop.DBus.Properties',sender='" + obj.DestName + "',member='PropertiesChanged'")
	dbusRemoveMatch("type='signal',path='" + string(obj.Path) + "',interface='org.bluez.Network1',sender='" + obj.DestName + "',member='PropertiesChanged'")

	obj.Connected.Reset()
	obj.Interface.Reset()
	obj.UUID.Reset()
}

func (obj *Network1) Connect(uuid string) (interface_ string, _err error) {
	_err = obj.core.Call("org.bluez.Network1.Connect", 0, uuid).Store(&interface_)
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

func (obj *Network1) Disconnect() (_err error) {
	_err = obj.core.Call("org.bluez.Network1.Disconnect", 0).Store()
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

type dbusPropertyNetwork1Connected struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyNetwork1Connected) SetValue(notwritable interface{}) {
	fmt.Println("org.bluez.Network1.Connected is not writable")
}

func (this *dbusPropertyNetwork1Connected) Get() bool {
	v, _ := this.GetValue()
	return v.(bool)
}
func (this *dbusPropertyNetwork1Connected) GetValue() (interface{} /*bool*/, error) {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "org.bluez.Network1", "Connected").Store(&r)
	if err == nil && r.Signature().String() == "b" {
		return r.Value().(bool), nil
	}
	return *new(bool), err
}
func (this *dbusPropertyNetwork1Connected) GetType() reflect.Type {
	return reflect.TypeOf((*bool)(nil)).Elem()
}

type dbusPropertyNetwork1Interface struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyNetwork1Interface) SetValue(notwritable interface{}) {
	fmt.Println("org.bluez.Network1.Interface is not writable")
}

func (this *dbusPropertyNetwork1Interface) Get() string {
	v, _ := this.GetValue()
	return v.(string)
}
func (this *dbusPropertyNetwork1Interface) GetValue() (interface{} /*string*/, error) {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "org.bluez.Network1", "Interface").Store(&r)
	if err == nil && r.Signature().String() == "s" {
		return r.Value().(string), nil
	}
	return *new(string), err
}
func (this *dbusPropertyNetwork1Interface) GetType() reflect.Type {
	return reflect.TypeOf((*string)(nil)).Elem()
}

type dbusPropertyNetwork1UUID struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyNetwork1UUID) SetValue(notwritable interface{}) {
	fmt.Println("org.bluez.Network1.UUID is not writable")
}

func (this *dbusPropertyNetwork1UUID) Get() string {
	v, _ := this.GetValue()
	return v.(string)
}
func (this *dbusPropertyNetwork1UUID) GetValue() (interface{} /*string*/, error) {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "org.bluez.Network1", "UUID").Store(&r)
	if err == nil && r.Signature().String() == "s" {
		return r.Value().(string), nil
	}
	return *new(string), err
}
func (this *dbusPropertyNetwork1UUID) GetType() reflect.Type {
	return reflect.TypeOf((*string)(nil)).Elem()
}

func NewNetwork1(destName string, path dbus.ObjectPath) (*Network1, error) {
	if !path.IsValid() {
		return nil, errors.New("The path of '" + string(path) + "' is invalid.")
	}

	core := getBus().Object(destName, path)

	obj := &Network1{Path: path, DestName: destName, core: core, signals: make(map[<-chan *dbus.Signal]struct{})}

	obj.Connected = &dbusPropertyNetwork1Connected{&property.BaseObserver{}, core}
	obj.Interface = &dbusPropertyNetwork1Interface{&property.BaseObserver{}, core}
	obj.UUID = &dbusPropertyNetwork1UUID{&property.BaseObserver{}, core}

	dbusAddMatch("type='signal',path='" + string(path) + "',interface='org.freedesktop.DBus.Properties',sender='" + destName + "',member='PropertiesChanged'")
	dbusAddMatch("type='signal',path='" + string(path) + "',interface='org.bluez.Network1',sender='" + destName + "',member='PropertiesChanged'")
	sigChan := obj._createSignalChan()
	go func() {
		typeString := reflect.TypeOf("")
		typeKeyValues := reflect.TypeOf(map[string]dbus.Variant{})
		typeArrayValues := reflect.TypeOf([]string{})
		for v := range sigChan {
			if v.Name == "org.freedesktop.DBus.Properties.PropertiesChanged" &&
				len(v.Body) == 3 &&
				reflect.TypeOf(v.Body[0]) == typeString &&
				reflect.TypeOf(v.Body[1]) == typeKeyValues &&
				reflect.TypeOf(v.Body[2]) == typeArrayValues &&
				v.Body[0].(string) == "org.bluez.Network1" {
				props := v.Body[1].(map[string]dbus.Variant)
				for key, _ := range props {
					if false {
					} else if key == "Connected" {
						obj.Connected.Notify()

					} else if key == "Interface" {
						obj.Interface.Notify()

					} else if key == "UUID" {
						obj.UUID.Notify()
					}
				}
			} else if v.Name == "org.bluez.Network1.PropertiesChanged" && len(v.Body) == 1 && reflect.TypeOf(v.Body[0]) == typeKeyValues {
				for key, _ := range v.Body[0].(map[string]dbus.Variant) {
					if false {
					} else if key == "Connected" {
						obj.Connected.Notify()

					} else if key == "Interface" {
						obj.Interface.Notify()

					} else if key == "UUID" {
						obj.UUID.Notify()
					}
				}
			}
		}
	}()

	runtime.SetFinalizer(obj, func(_obj *Network1) { DestroyNetwork1(_obj) })
	return obj, nil
}
