/*This file is automatically generated by pkg.deepin.io/dbus-generator. Don't edit it*/
package wfd

import "pkg.deepin.io/lib/dbus"
import "pkg.deepin.io/lib/dbus/property"
import "reflect"
import "sync"
import "runtime"
import "fmt"
import "errors"

/*prevent compile error*/
var _ = fmt.Println
var _ = runtime.SetFinalizer
var _ = sync.NewCond
var _ = reflect.TypeOf
var _ = property.BaseObserver{}

type ObjectManager struct {
	Path     dbus.ObjectPath
	DestName string
	core     *dbus.Object

	signals       map[<-chan *dbus.Signal]struct{}
	signalsLocker sync.Mutex
}

func (obj *ObjectManager) _createSignalChan() <-chan *dbus.Signal {
	obj.signalsLocker.Lock()
	ch := getBus().Signal()
	obj.signals[ch] = struct{}{}
	obj.signalsLocker.Unlock()
	return ch
}
func (obj *ObjectManager) _deleteSignalChan(ch <-chan *dbus.Signal) {
	obj.signalsLocker.Lock()
	delete(obj.signals, ch)
	getBus().DetachSignal(ch)
	obj.signalsLocker.Unlock()
}
func DestroyObjectManager(obj *ObjectManager) {
	obj.signalsLocker.Lock()
	defer obj.signalsLocker.Unlock()
	if obj.signals == nil {
		return
	}
	for ch, _ := range obj.signals {
		getBus().DetachSignal(ch)
	}
	obj.signals = nil

	runtime.SetFinalizer(obj, nil)

	dbusRemoveMatch("type='signal',path='" + string(obj.Path) + "',interface='org.freedesktop.DBus.Properties',sender='" + obj.DestName + "',member='PropertiesChanged'")
	dbusRemoveMatch("type='signal',path='" + string(obj.Path) + "',interface='org.freedesktop.DBus.ObjectManager',sender='" + obj.DestName + "',member='PropertiesChanged'")

	dbusRemoveMatch("type='signal',path='" + string(obj.Path) + "',interface='org.freedesktop.DBus.ObjectManager',sender='" + obj.DestName + "',member='InterfacesAdded'")

	dbusRemoveMatch("type='signal',path='" + string(obj.Path) + "',interface='org.freedesktop.DBus.ObjectManager',sender='" + obj.DestName + "',member='InterfacesRemoved'")

}

func (obj *ObjectManager) GetManagedObjects() (object_paths_interfaces_and_properties map[dbus.ObjectPath]map[string]map[string]dbus.Variant, _err error) {
	_err = obj.core.Call("org.freedesktop.DBus.ObjectManager.GetManagedObjects", 0).Store(&object_paths_interfaces_and_properties)
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

func (obj *ObjectManager) ConnectInterfacesAdded(callback func(object_path dbus.ObjectPath, interfaces_and_properties map[string]map[string]dbus.Variant)) func() {
	sigChan := obj._createSignalChan()
	go func() {
		for v := range sigChan {
			if v.Path != obj.Path || v.Name != "org.freedesktop.DBus.ObjectManager.InterfacesAdded" || 2 != len(v.Body) {
				continue
			}
			if reflect.TypeOf(v.Body[0]) != reflect.TypeOf((*dbus.ObjectPath)(nil)).Elem() {
				continue
			}
			if reflect.TypeOf(v.Body[1]) != reflect.TypeOf((*map[string]map[string]dbus.Variant)(nil)).Elem() {
				continue
			}

			callback(v.Body[0].(dbus.ObjectPath), v.Body[1].(map[string]map[string]dbus.Variant))
		}
	}()
	return func() {
		obj._deleteSignalChan(sigChan)
	}
}

func (obj *ObjectManager) ConnectInterfacesRemoved(callback func(object_path dbus.ObjectPath, interfaces []string)) func() {
	sigChan := obj._createSignalChan()
	go func() {
		for v := range sigChan {
			if v.Path != obj.Path || v.Name != "org.freedesktop.DBus.ObjectManager.InterfacesRemoved" || 2 != len(v.Body) {
				continue
			}
			if reflect.TypeOf(v.Body[0]) != reflect.TypeOf((*dbus.ObjectPath)(nil)).Elem() {
				continue
			}
			if reflect.TypeOf(v.Body[1]) != reflect.TypeOf((*[]string)(nil)).Elem() {
				continue
			}

			callback(v.Body[0].(dbus.ObjectPath), v.Body[1].([]string))
		}
	}()
	return func() {
		obj._deleteSignalChan(sigChan)
	}
}

func NewObjectManager(destName string, path dbus.ObjectPath) (*ObjectManager, error) {
	if !path.IsValid() {
		return nil, errors.New("The path of '" + string(path) + "' is invalid.")
	}

	core := getBus().Object(destName, path)

	obj := &ObjectManager{Path: path, DestName: destName, core: core, signals: make(map[<-chan *dbus.Signal]struct{})}

	dbusAddMatch("type='signal',path='" + string(obj.Path) + "',interface='org.freedesktop.DBus.ObjectManager',sender='" + obj.DestName + "',member='InterfacesAdded'")

	dbusAddMatch("type='signal',path='" + string(obj.Path) + "',interface='org.freedesktop.DBus.ObjectManager',sender='" + obj.DestName + "',member='InterfacesRemoved'")

	runtime.SetFinalizer(obj, func(_obj *ObjectManager) { DestroyObjectManager(_obj) })
	return obj, nil
}
